import QtQuick 2.12
import QtQuick.Controls 2.5
import QtQuick.Layouts 1.3
import QtQuick.Window 2.12
import org.ukui.kwin 2.0 as KWin
import org.kde.plasma 2.0 as PlasmaCore
import QtGraphicalEffects 1.0
import "TabletController.js" as TabletController
import IconTheme 1.0

TabletViewRootWindow {
    id : rootView

    //为了解决控制器模块的view，实现父类调用子类
    signal qmlViewSpaceClicked()
    signal qmlViewClosed()
    signal qmlClearAllAppWindow()
    //由于执行小窗口关闭动效时，会关闭多任务视图多次，导致崩溃，故增加此属性
    property bool alreadyCloseView: false

    Connections{
        target : rootView

        onQmlViewClosed:{
            if (!alreadyCloseView)
            {
                alreadyCloseView = true
                controller.closeMultitaskView()
            }
            if (tabletViewRootModel.count>0)
            {
                tabletViewRootModel.clear()
            }
        }
    }
    Connections{
        target : tabletViewMainWindow
        onQmlAppWindowRemovedForward:{
            for(var i = 0; i < tabletViewRootModel.count; i++){
                var info = tabletViewRootModel.get(i);
                if(info.id === id) {
                    tabletViewRootModel.remove(i);
                    return;
                }
            }
        }
    }

    TabletScrollViewArea {
        id : appArea
        x : 0
        y : Math.floor(scrollViewYStartPoint)
        width : Math.floor(tabletViewMain.width)
        height : Math.floor(scrollViewHeight)
        appModel : tabletViewRootModel
        rootRect : screenRect
    }

    TabletViewClearAllWindowButton {
        id : clearAllWindow
        property var controller : new TabletController.Controller(multitaskViewModel, clearAllWindow, multitaskViewManager, ["none"])
    }

}//Rectangle rootView
